package com.ruoyi.bst.lightingNum.mapper;

import java.util.List;
import com.ruoyi.bst.lightingNum.domain.LightingNum;
import com.ruoyi.bst.lightingNum.domain.LightingNumVO;
import com.ruoyi.bst.lightingNum.domain.LightingNumQuery;
import com.ruoyi.bst.order.domain.OrderQuery;
import com.ruoyi.common.domain.vo.LongIntegerVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.security.core.parameters.P;

/**
 * 爆灯次数列表Mapper接口
 *
 * @author ruoyi
 * @date 2025-04-26
 */
public interface LightingNumMapper
{
    /**
     * 查询爆灯次数列表
     *
     * @param id 爆灯次数列表主键
     * @return 爆灯次数列表
     */
    LightingNumVO selectLightingNumById(Long id);

    /**
     * 查询爆灯次数列表列表
     *
     * @param query 爆灯次数列表
     * @return 爆灯次数列表集合
     */
    List<LightingNumVO> selectLightingNumList(@Param("query")LightingNumQuery query);

    /**
     * 新增爆灯次数列表
     *
     * @param lightingNum 爆灯次数列表
     * @return 结果
     */
    int insertLightingNum(LightingNum lightingNum);

    /**
     * 批量新增爆灯次数列表
     */
    int batchInsert(@Param("list") List<? extends LightingNum> list);

    /**
     * 批量修改爆灯次数列表
     */
    int batchUpdate(@Param("list") List<? extends LightingNum> list);

    /**
     * 修改爆灯次数列表
     *
     * @param lightingNum 爆灯次数列表
     * @return 结果
     */
    public int updateLightingNum(@Param("data") LightingNum lightingNum);

    /**
     * 删除爆灯次数列表
     *
     * @param id 爆灯次数列表主键
     * @return 结果
     */
    int deleteLightingNumById(Long id);

    /**
     * 批量删除爆灯次数列表
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteLightingNumByIds(Long[] ids);

    /**
     * 查询用户爆灯次数
     * @param userId
     * @return
     */
    Integer selectLightingNumberForUpdate(@Param("userId") Long userId,@Param("storeId")Long storeId);


    int addLightingNum(@Param("userId") Long userId,@Param("storeId") Long storeId, @Param("number")Integer number);

    LightingNumVO selectLightingNumByUserId(@Param("userId") Long userId,@Param("storeId") Long storeId);

    public int reduceLightingNum(@Param("data") LightingNum data,@Param("query") OrderQuery query);

    List<LongIntegerVO> assembleLightingNum(@Param("query") LightingNumQuery query);

    Integer selectCount(@Param("query") LightingNumQuery query);
}
